--==========================================================================================
-- Control de l'état des portes du MI8 et retourne true si la porte est ouverte, false sinon.
-- 
-- 1/ Charger dans l'éditeur de mission le présent fichier avec : "EXECUTER FICHIER SCRIPT" avec fichier = FG04.porteOuverteMI8.lua
-- 2/ utilisation : on ajoute une règle "LUA PREDICATE" avec la commande suivante : 
--                 return FG04.porteOuverteMI8("MI 01", "CARGO")     -- teste portes arrière CARGO
--                 return FG02.porteOuverteMI8("MI 01", "ARR_G")     -- teste 1 porte arrière gauche
--                 return FG04.porteOuverteMI8("MI 01", "TOUTES")    -- teste que portes arrière gauche et cargo sont ouvertes

--
-- Cette fonction a besoin de 2 paramètres :
-- 1> Nom de l'unité à contrôler (ex :"MI 01" )
-- 2> Code porte à contrôler (3 possibles) :
--      "ARR_G"    = contrôle portes arrière gauche
--		"TOUTES"   = teste si portes arrière gauche et cargo sont ouvertes
--		"CARGO"    = teste si portes arrière CARGO sont ouvertes
--
-- juillet/2018 - par FullGas
--
--
FG04 = {}   -- NE PAS RETIRER !
-----------------------------------------------------------------------------------------------
function FG04.porteOuverteMI8(helName, Porte)
	local u, argdrawv = {}
	local codes = {}
	local code = ""
    local ret = false
	if not Unit.getByName(helName) then				-- seulement pour unités avec slot client pris, car plantage si s/slot libre
		trigger.action.outText("Erreur dans FG04.porteOuverteMI8, l'hélico " .. helName .. " n'existe pas ! ", 30)
		return nil
	else
		u = Unit.getByName(helName)
			if string.upper(Porte) == "ARR_G" then
			codes[#codes+1] = 38	-- portes arrière gauche à tester
			elseif string.upper(Porte) == "CARGO" then
			codes[#codes+1] = 86	-- portes arrières Cargo
			elseif string.upper(Porte) == "TOUTES" then
			codes[#codes+1] = 38	-- portes avant à tester
			codes[#codes+1] = 86	-- portes arrières Cargo
			end
			
			if #codes == 0 then			-- si params "Porte" inconnu => message erreur
				trigger.action.outText("Erreur dans FG04.porteOuverteMI8, pour " .. helName .. ", le type de porte " .. tostring(Porte) .. " n'est pas correct (à contrôler) !", 30)
				return nil
			else

				-- Tester tous les codes portes à vérifier 1 ou 2 ou 1 et 2 selon params "Porte"
				local pass1 = true
				for i=1, #codes do
					argdrawv = u:getDrawArgumentValue(codes[i])
										
					if argdrawv ~= nil then
						--if codes[i] == 38 and argdrawv > 0.899 then argdrawv = 1; end		-- ajuster le maxi pour portes avant				
						if argdrawv == 1 then  
							if pass1 == true then		--si premier passage forcer ret
								pass1 = false
								ret = true;	  			-- porte détectée ouverte
							else
								ret = ret and true    	-- porte détectée ouverte
							end
						else
							pass1 = false						
							ret = false  				-- porte détectée fermée
						end
					end
				end
			end
		return ret		-- dans tous les cas on retourne l'état de la porte contrôlée (pour les appels par prog lua)
    end
end

-- ex : FG04.porteOuverteMI8("MI 09 HOT","CARGO")