-------------------------------------------------------------------------------------
-- 2 fonction LUA  1> spawn d'un personnel static (sur le modèle des personnages animés du super carrier)
--                 2> détruire un personnel crée précédemment
-- FullGas 30/06/2020
--
-- Utilisation : charger MIST dans l'éditeur, puis cette fonction
--               Elle peut ensuite être utilisée dans les ACTION via exécuter script LUA
-- Fonctionnement 1> On appelle la fonction avec 3 paramètres :
--                  0. PersonelName = le nom qu'on veut donner au personnage (nécessaire pour pouvoir le détruire ensuite)
--                  1. zoneName     = le nom de la zone aux coordonnées de laquelle on veut faire spawner le personnage
--                  2. PersonelType = le type de personnage qu'on veut faire spawner parmi les suivants :
--							"carrier_shooter"          (ne bouge presque pas)
--							"us carrier shooter"       (bouge bien)
--							"us carrier tech"		   (bouge bien)									
--							"Carrier Seaman"		   (ne bouge presque pas)								
--							"Carrier LSO Personell 5"  (ne bouge presque pas)																			
--							"Carrier LSO Personell 4"  (ne bouge presque pas)																		
--							"Carrier LSO Personell 3"  (ne bouge presque pas)																		
--							"Carrier LSO Personell 2"  (ne bouge presque pas)																		
--							"Carrier LSO Personell 1"  (ne bouge presque pas)														
--							"Carrier LSO Personell"    (ne bouge presque pas)									
--							"Carrier Airboss"          (ne bouge presque pas)
--                   3. livery_id = couleur du personnage. 
--									> Seuls "us carrier shooter" et "us carrier tech" peuvent avoir différentes couleurs parmi :
--                                        "blue", "brown", "green", "purple", "red", "white", "yellow"
--                                  > pour les autres personnages (qui n'ont qu'une couleur => renseigner nil dans le paramètre couleur , cela donnera la couleur par défaut.
--					 4. heading = cap d'orientation du personnage (0 à 359) en numérique

---- exemple d'appel ACTION EXECUTER SCRIPT LUA ------------------------------------------
-- mist.spawnPersonnel("MECA -1", "MECA -1", "us carrier tech", "blue", 270) => fait apparaitre le mécano nommé "MECA -1" dans la zone nommée "MECA -1" ayant l'apparence "carrier_shooter" de couleur "blue" au cap 270,".
-- mist.spawnPersonnel("Perso2", "Zone2", "carrier_seaman_USA", nil, 110) => nil = couleur par défaut".
-------------------------------------------------------------------------------------
mist.personnelSpawned = {}
--------------------------------------------------------------------------------------------
function mist.spawnPersonnel(PersonelName, zoneName, PersonelType, livery_id, heading)
	local shapeNames = { ["us carrier shooter"] = "carrier_shooter",
						 ["us carrier tech"] = "carrier_tech_USA",
						 ["Carrier Seaman"] = "carrier_seaman_USA",
						 ["Carrier LSO Personell 5"] = "carrier_lso5_usa",
						 ["Carrier LSO Personell 4"] = "carrier_lso4_usa",
						 ["Carrier LSO Personell 3"] = "carrier_lso3_usa",
						 ["Carrier LSO Personell 2"] = "carrier_lso2_usa",
						 ["Carrier LSO Personell 1"] = "carrier_lso1_usa",
						 ["Carrier LSO Personell"] = "carrier_lso_usa",
						 ["Carrier Airboss"] = "carrier_airboss_USA"}
	-- gestion des liveries
	if PersonelType == "us carrier shooter" or PersonelType == "us carrier tech" then
		if not (livery_id == "blue" or livery_id == "brown" or livery_id == "green" or livery_id == "purple"
           or livery_id == "red" or livery_id == "white" or livery_id == "yellow") then
		   livery_id = nil		-- si couleur non reconnue => prendre couleur par défaut
		end
	else						-- pour personnage n'ayant qu'1 couleur => prendre la couleur par défaut
		livery_id = nil
	end
	if  (  PersonelType == "carrier_shooter"         or PersonelType == "us carrier shooter" 
		or PersonelType == "us carrier tech"         or PersonelType == "Carrier Seaman"
		or PersonelType == "Carrier LSO Personell 5" or PersonelType == "Carrier LSO Personell 4"
		or PersonelType == "Carrier LSO Personell 3" or PersonelType == "Carrier LSO Personell 2" 
		or PersonelType == "Carrier LSO Personell 1" or PersonelType == "Carrier LSO Personell"
		or PersonelType == "Carrier Airboss") then
		
		if type(zoneName) == 'string' then
			local zone = trigger.misc.getZone(zoneName)
			if zone then
				heading = (((heading / 180) + 90) * math.pi)   -- correction decalage heading
				local newObj = mist.dynAddStatic({ country = 2, category = "static", categoryStatic = "Personnel", x = zone.point.x, y = zone.point.z, type = PersonelType, shapeName = shapeNames[PersonelType], heading = heading, livery_id = livery_id})		-- crée un objet static
				mist.personnelSpawned[PersonelName] = newObj:getName()		-- enregistre correspondance entre nom donné par missionmaker, et nom donné automatiquement par DCS
				return newObj 	-- retourne objet crée
			else		
				trigger.action.outText("ERREUR : dans 'spawnPersonnel', nom de zone incorrect. Vérifier votre script d'appel.",15)
				return false	-- échec
			end
		else
			trigger.action.outText("ERREUR : dans 'spawnPersonnel', nom de zone incorrect. Vérifiez votre script d'appel.",15)
			return false	-- échec
		end
	else
		trigger.action.outText("ERREUR : dans 'spawnPersonnel', type de personnel incorrect. Vérifier votre script d'appel.",15)
		return false	-- échec
	end
end
-----------Effacer un personnel (static)--------------------------------------------------------------
-- fonction LUA  > spawn d'un personnel static (sur le modèle des personnages animés du super carrier)
-- FullGas 30/06/2020
-- Fonctionnement 2> -- passer le nom donné au static lors de sa création
					 -- ex :
					 -- mist.detruitPersonnel("MECA -1") => fait disparaitre le personnel crée précédemment sous le nom de : "MECA -1"
------------------------------------------------------------------------------------------------------
function mist.detruitPersonnel(PersonelName)
    local u = ""
	if StaticObject.getByName(PersonelName) then						  -- si l'objet a été crée à l'éditeur
		u = StaticObject.getByName(PersonelName)						  -- récupérer objet static à détruire
		u:destroy()
    elseif mist.personnelSpawned[PersonelName] then							  -- si le nom de personnage est trouvé
        if StaticObject.getByName(mist.personnelSpawned[PersonelName]) then   -- si l'objet a été crée par la fonction de spawn
            u = StaticObject.getByName(mist.personnelSpawned[PersonelName]) -- récupérer objet static à détruire
            u:destroy()
            mist.personnelSpawned[PersonelName] = nil
        else
            trigger.action.outText("ERREUR dans mist.detruitPersonnel : Nom du personnage à détruire non trouvé. Vérifez le script d'appel", 10)
        end
    else
		trigger.action.outText("ERREUR dans mist.detruitPersonnel : Nom du personnage à détruire non trouvé. Vérifez le script d'appel", 10)
	end	
end
--=====================================================================================================